import { Component, h, Prop, Host } from "@stencil/core";
import colors from "../../global/colors";
const fillcolors = {
    primary: colors.brandMain,
    secondary: "white"
};
export class Button {
    constructor() {
        this.variant = "primary";
        this.state = "enabled";
    }
    render() {
        const classAttributes = ["hy-button", this.variant, this.state];
        const iconFillColor = fillcolors[this.variant];
        return (h(Host, null,
            h("button", { class: classAttributes.join(" ") },
                !!this.icon && (h("span", { class: "button-icon button-icon-left" },
                    h("hy-icon", { icon: this.icon, fill: iconFillColor, size: 13 }))),
                h("span", { class: "button-text" },
                    h("slot", null)),
                !!this.iconRight && (h("span", { class: "button-icon button-icon-right" },
                    h("hy-icon", { icon: this.iconRight, fill: iconFillColor, size: 13 }))))));
    }
    static get is() { return "hy-button"; }
    static get originalStyleUrls() { return {
        "$": ["button.scss"]
    }; }
    static get styleUrls() { return {
        "$": ["button.css"]
    }; }
    static get properties() { return {
        "variant": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "ButtonVariants",
                "resolved": "\"primary\" | \"secondary\"",
                "references": {
                    "ButtonVariants": {
                        "location": "import",
                        "path": "../../utils/utils"
                    }
                }
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "variant",
            "reflect": false,
            "defaultValue": "\"primary\""
        },
        "state": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "ButtonStates",
                "resolved": "\"disabled\" | \"enabled\"",
                "references": {
                    "ButtonStates": {
                        "location": "import",
                        "path": "../../utils/utils"
                    }
                }
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "state",
            "reflect": false,
            "defaultValue": "\"enabled\""
        },
        "icon": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": true,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "icon",
            "reflect": false
        },
        "iconRight": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": true,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "icon-right",
            "reflect": false
        }
    }; }
}
