import { Component, Host, Prop, h } from '@stencil/core';
import { LinkVariants } from "../../utils/utils";
export class Link {
    constructor() {
        this.variant = LinkVariants.default;
        this.linkContent = '';
        this.isExternal = false;
    }
    render() {
        const classAttributes = ["hy-link", this.variant];
        const target = this.isExternal ? "_blank" : "_self";
        return (h(Host, null,
            h("a", { "aria-label": this.ariaLabel, class: classAttributes.join(" "), href: this.url, target: target }, this.linkContent)));
    }
    static get is() { return "hy-link"; }
    static get encapsulation() { return "shadow"; }
    static get originalStyleUrls() { return {
        "$": ["link.scss"]
    }; }
    static get styleUrls() { return {
        "$": ["link.css"]
    }; }
    static get properties() { return {
        "variant": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "LinkVariants",
                "resolved": "LinkVariants.default | LinkVariants.paragraph",
                "references": {
                    "LinkVariants": {
                        "location": "import",
                        "path": "../../utils/utils"
                    }
                }
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "variant",
            "reflect": false,
            "defaultValue": "LinkVariants.default"
        },
        "linkContent": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "link-content",
            "reflect": false,
            "defaultValue": "''"
        },
        "url": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": true,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "url",
            "reflect": false
        },
        "ariaLabel": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": true,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "aria-label",
            "reflect": false
        },
        "isExternal": {
            "type": "boolean",
            "mutable": false,
            "complexType": {
                "original": "boolean",
                "resolved": "boolean",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "is-external",
            "reflect": false,
            "defaultValue": "false"
        }
    }; }
}
